import { useEffect, useState } from 'react';
export var LazyListStates;
(function (LazyListStates) {
    LazyListStates["RENDERED"] = "rendered";
    LazyListStates["FIRST_PAGE_LOADING"] = "firstPageLoading";
    LazyListStates["FIRST_PAGE_LOADED"] = "firstPageLoaded";
    LazyListStates["INFINITE_LOADING"] = "infiniteLoading";
    LazyListStates["EMPTY"] = "empty";
})(LazyListStates || (LazyListStates = {}));
export function useConfirmLoading(_a) {
    var hasNextPage = _a.hasNextPage, loading = _a.loading, shouldConfirmInfiniteLoading = _a.shouldConfirmInfiniteLoading, withPrefetchedData = _a.withPrefetchedData;
    var _b = useState(withPrefetchedData
        ? LazyListStates.FIRST_PAGE_LOADED
        : LazyListStates.RENDERED), status = _b[0], setStatus = _b[1];
    var _c = useState(shouldConfirmInfiniteLoading), confirmLoading = _c[0], setConfirmLoading = _c[1];
    useEffect(function () {
        if (status === LazyListStates.RENDERED && loading) {
            setStatus(LazyListStates.FIRST_PAGE_LOADING);
        }
        else if (status === LazyListStates.FIRST_PAGE_LOADING && !loading) {
            setStatus(LazyListStates.FIRST_PAGE_LOADED);
        }
        else if (status === LazyListStates.FIRST_PAGE_LOADED && loading) {
            setStatus(LazyListStates.INFINITE_LOADING);
        }
    }, [status, loading, setStatus]);
    useEffect(function () {
        if ((status === LazyListStates.RENDERED ||
            status === LazyListStates.FIRST_PAGE_LOADED) &&
            !hasNextPage) {
            setStatus(LazyListStates.EMPTY);
        }
    }, [status, hasNextPage, setStatus]);
    useEffect(function () {
        if (status === LazyListStates.INFINITE_LOADING ||
            status === LazyListStates.EMPTY) {
            setConfirmLoading(false);
        }
    }, [status, setConfirmLoading]);
    return confirmLoading;
}
