import React, { useState, useEffect } from 'react';
import { Icon } from "./..";
import { DropMenuItemButton, DropMenuItemContainer, DropMenuItemTitle, DropMenuList, DropMenuOpenButton, TinyDropMenuWrapper, } from './styles';
import { DropDirection, ItemsDirection } from './constants';
import { TinyDropMenuContext, useTinyDropMenuContext, } from './TinyDropMenuContext';
export var TinyDropMenu = function (_a) {
    var children = _a.children, closeOnItemClick = _a.closeOnItemClick, _b = _a.color, color = _b === void 0 ? 'primary' : _b, _c = _a.dropDirection, dropDirection = _c === void 0 ? DropDirection.UP : _c, _d = _a.itemsDirection, itemsDirection = _d === void 0 ? ItemsDirection.RIGHT : _d, renderTrigger = _a.renderTrigger, onOpen = _a.onOpen, onClose = _a.onClose, openOutside = _a.openOutside;
    var _e = useState(false), open = _e[0], setOpen = _e[1];
    var _f = useState(false), closeAnimate = _f[0], setCloseAnimate = _f[1];
    var openMenu = function () {
        setOpen(true);
        if (onOpen) {
            onOpen();
        }
    };
    useEffect(function () {
        if (openOutside !== undefined) {
            setOpen(openOutside);
        }
    }, [openOutside]);
    var closeMenu = function () {
        setCloseAnimate(true);
        setTimeout(function () {
            setOpen(false);
            setCloseAnimate(false);
            if (onClose) {
                onClose();
            }
        }, 200);
    };
    return (React.createElement(TinyDropMenuWrapper, null,
        React.createElement(TinyDropMenuContext.Provider, { value: {
                color: color,
                dropDirection: dropDirection,
                itemsDirection: itemsDirection,
                closeMenu: closeOnItemClick ? closeMenu : undefined,
            } },
            renderTrigger ? (renderTrigger({ open: open, openMenu: openMenu, closeMenu: closeMenu })) : (React.createElement(DropMenuOpenButton, { color: color, open: open && !closeAnimate, onClick: open ? closeMenu : openMenu, dropDirection: dropDirection },
                React.createElement(Icon, { name: "ellipsis-v", size: "large", fitted: true, color: "white" }))),
            open && (React.createElement(DropMenuList, { dropDirection: dropDirection, closeAnimate: closeAnimate }, children)))));
};
export var TinyDropMenuItem = function (_a) {
    var onClick = _a.onClick, disabled = _a.disabled, renderIcon = _a.renderIcon, renderTitle = _a.renderTitle;
    var _b = useState(false), hovering = _b[0], setHovering = _b[1];
    var _c = useTinyDropMenuContext(), color = _c.color, closeMenu = _c.closeMenu, dropDirection = _c.dropDirection, itemsDirection = _c.itemsDirection;
    var onItemClick = function () {
        onClick();
        if (closeMenu) {
            closeMenu();
        }
    };
    return (React.createElement(DropMenuItemButton, { dropDirection: dropDirection, itemsDirection: itemsDirection, color: color, onClick: onItemClick, disabled: disabled, onMouseEnter: function () { return setHovering(true); }, onMouseLeave: function () { return setHovering(false); } },
        renderIcon({ hovering: hovering }),
        React.createElement(DropMenuItemContainer, { color: color, itemsDirection: itemsDirection },
            React.createElement(DropMenuItemTitle, null, renderTitle()))));
};
