import React from 'react';
import { Icon, InfoTooltip } from "../../components";
var getAuditPopover = function (sme, _a, auditEnabled, reviewKiData) {
    var auditReviewMode = _a.auditReviewMode, handedOver = _a.handedOver, _b = _a.rejectedTeams, rejectedTeams = _b === void 0 ? [] : _b;
    if (auditEnabled) {
        if (sme && handedOver) {
            var content = 'You have handed over this Teaching Session to a Knowledge Expert for Conversion.';
            return (React.createElement(React.Fragment, null,
                React.createElement("div", null,
                    React.createElement("b", null, "Handed-Over")),
                React.createElement("div", null, content)));
        }
        if (sme && !auditReviewMode && rejectedTeams.length > 0) {
            var content = 'Your Reviewers refused to accept the results from your Teaching Session. ' +
                'Please check the comments in your Teaching Session.';
            return (React.createElement(React.Fragment, null,
                React.createElement("div", null,
                    React.createElement("b", null, "Review Refused!")),
                React.createElement("div", null, content)));
        }
        if (!sme && reviewKiData) {
            var approved = reviewKiData.approved, refused = reviewKiData.refused, pending_1 = reviewKiData.pending;
            return (React.createElement(React.Fragment, null,
                React.createElement("div", null,
                    React.createElement("b", null, "Review Updated!"),
                    React.createElement("br", null),
                    React.createElement("span", null, "Conversion Session contains:")),
                React.createElement("br", null),
                React.createElement("div", null,
                    React.createElement("span", null,
                        React.createElement("b", null, approved),
                        " Approved Knowledge Items"),
                    React.createElement("br", null),
                    React.createElement("span", null,
                        React.createElement("b", null, refused),
                        " Refused Knowledge Items"),
                    React.createElement("br", null),
                    React.createElement("span", null,
                        React.createElement("b", null, pending_1),
                        " Unapproved Knowledge Items"))));
        }
    }
    return null;
};
export var SessionStepPopover = function (_a) {
    var sme = _a.sme, session = _a.session, auditEnabled = _a.auditEnabled, reviewKiData = _a.reviewKiData;
    var popoverData = getAuditPopover(sme, session, auditEnabled, reviewKiData);
    return (popoverData && (React.createElement(InfoTooltip, { iconType: "info", data: popoverData, placing: "top", width: 250 },
        React.createElement(Icon, { name: "info", size: "mini", fitted: true, circular: true, inverted: true }))));
};
