import { getReviewKiData, getReviewKiStatistics } from '../getReviewKiData';
import { getParticipantIds, getReviewerIds, isOwner, isParticipantInReview, isReviewer, } from "../../utils/session";
export var CONTINUE_TEACHING = 'Continue Teaching';
export var CONTINUE_CONVERSION = 'Continue Conversion';
export var START_TEACHING = 'Start Teaching';
export var START_CONVERSION = 'Start Conversion';
export var VIEW = 'View';
export var REVIEW = 'Review';
export var START_REVIEW = 'Start Review';
export var getSessionButtonText = function (session, sme, currentUserId, auditEnabled) {
    if (sme === void 0) { sme = false; }
    var archived = session.archived, teachingOwnerId = session.teachingOwnerId, conversionOwnerId = session.conversionOwnerId, handedOver = session.handedOver, auditReviewMode = session.auditReviewMode;
    var reviewerIds = getReviewerIds(sme, session, auditEnabled);
    var participantIds = getParticipantIds(sme, session);
    var reviewKiData = getReviewKiData(session.auditKiReview || {});
    var reviewKiStatistics = getReviewKiStatistics(reviewKiData);
    var owner = isOwner(sme, currentUserId, {
        teachingOwnerId: teachingOwnerId,
        conversionOwnerId: conversionOwnerId,
    });
    var reviewer = isReviewer(currentUserId, reviewerIds);
    var participant = isParticipantInReview(currentUserId, participantIds);
    if (archived ||
        (sme && handedOver) ||
        (owner && auditEnabled && sme && auditReviewMode)) {
        return VIEW;
    }
    if (owner) {
        return sme ? CONTINUE_TEACHING : CONTINUE_CONVERSION;
    }
    if (reviewer && !auditEnabled) {
        return participant ? REVIEW : START_REVIEW;
    }
    if (!teachingOwnerId && !conversionOwnerId) {
        return START_TEACHING;
    }
    if (!sme && !conversionOwnerId) {
        return START_CONVERSION;
    }
    if (auditEnabled) {
        var pending_1 = reviewKiStatistics.pending, partialRefuse = reviewKiStatistics.partialRefuse, inProgress = reviewKiStatistics.inProgress;
        var reviewRequired = pending_1 || partialRefuse || inProgress;
        return reviewer && (sme ? auditReviewMode : reviewRequired) ? REVIEW : VIEW;
    }
    return VIEW;
};
